#include "coordinate_system.h"

#define Ax fields[0][0]->value()
#define Ay fields[0][1]->value()
#define Bx fields[1][0]->value()
#define By fields[1][1]->value()
#define Cx fields[2][0]->value()
#define Cy fields[2][1]->value()
#define Dx (Ax + Cx - Bx)
#define Dy (Ay + Cy - By)

CoordinateSystem::CoordinateSystem(QWidget *parent) : QWidget(parent) {
    QGridLayout *layout = new QGridLayout();
    colordialog = new QColorDialog();
    QPushButton *color = new QPushButton("Color", this);
    
    QLabel* x = new QLabel("X", this);
    QLabel* y = new QLabel("Y", this);
    layout->addWidget(x, 0, 1);
    layout->addWidget(y, 0, 2);
    
    for (short i = 0; i < 3; i++) {
        for (short j = 0; j < 2; j++) {
            fields[i][j] = new QSpinBox(this);
            fields[i][j]->setFixedWidth(60);
            fields[i][j]->setSingleStep(10);
            layout->addWidget(fields[i][j], i+1, j+1);
            connect(fields[i][j], QOverload<int>::of(&QSpinBox::valueChanged), this, &CoordinateSystem::up);
        }
    }
    
    button = new QPushButton("Draw", this);    
    QPushButton *clearb = new QPushButton("Clear", this);
    clearb->setFixedWidth(60);
    color->setFixedWidth(60);
    layout->addWidget(color,4,1);
    layout->addWidget(clearb,4,2);
    layout->addWidget(button,5,1,1,2);
    QWidget *container = new QWidget(this);
    container->setLayout(layout);
    connect(button, &QPushButton::clicked, this, &CoordinateSystem::onButtonClick);
    connect(color, &QPushButton::clicked, this, &CoordinateSystem::color);
    connect(clearb, &QPushButton::clicked, this, &CoordinateSystem::clear);
}
void CoordinateSystem::up() {update();}
void CoordinateSystem::color() {colordialog->show();choosen=1;}
void CoordinateSystem::clear() {lines.clear();colors.clear();update();}
void CoordinateSystem::paintEvent(QPaintEvent*) {
    bool drawn = false;
    painter = new QPainter(this);
    painter->setRenderHint(QPainter::Antialiasing);
    painter->drawLine(0, centerY, width(), centerY);
    painter->drawLine(centerX, 0, centerX, height());
    painter->drawLine(centerX - 5, 11, centerX, 0);
    painter->drawLine(centerX + 5, 11, centerX, 0);
    painter->drawLine(11, centerY - 5, 0, centerY);
    painter->drawLine(11, centerY + 5, 0, centerY);    
    for (short i = centerX; i < width(); i += step)  
        painter->drawLine(i, centerY - 5, i, centerY + 5);
    for (short i = centerX; i > 0; i -= step)        {
        painter->drawLine(i, centerY - 5, i, centerY + 5);
        painter->drawText(i - step - 20, centerY + 15, QString::number(-step));}
    
    for (short i = centerY; i < height(); i += step) {
        painter->drawLine(centerX - 5, i, centerX + 5, i);
        if (!drawn && width() > 250 && height() > 500) 
            painter->drawText(centerX + 5, centerY - 5 + step, QString::number(-step));
        drawn = true;
    }

    for (short i = centerY; i > 0; i -= step) 
        painter->drawLine(centerX - 5, i, centerX + 5, i);
    short newMin1 = -centerX;
    if (fields[0][0]->minimum() != newMin1)
    for (char j = 0; j < 3; j++) {
                fields[j][0]->blockSignals(true);
                fields[j][0]->setRange(newMin1, 0);
                fields[j][0]->blockSignals(false);
    }
    short newMin = centerY;
    if (fields[0][1]->maximum() != newMin)
    for (char j = 0; j < 3; j++) {
                fields[j][1]->blockSignals(true);
                fields[j][1]->setRange(0,newMin);
                fields[j][1]->blockSignals(false);
    }
    for (char a = 0; a < lines.size() / 8; a++) {
        painter->setPen(Qt::NoPen);
        painter->setBrush(Qt::gray);
        painter->drawPolygon(QPolygon()
            << QPoint(lines[a*8] + centerX, centerY - lines[a*8+1])
            << QPoint(lines[a*8+2] + centerX, centerY - lines[a*8+3])
            << QPoint(lines[a*8+4] + centerX, centerY - lines[a*8+5])
            << QPoint(lines[a*8+6] + centerX, centerY - lines[a*8+7])
        );
        painter->setPen(colors[a]);
        painter->drawLine(lines[a*8] + centerX, centerY - lines[a*8+1], lines[a*8+4] + centerX, centerY - lines[a*8+5]);
        painter->drawLine(lines[a*8+6] + centerX, centerY - lines[a*8+7], lines[a*8+2] + centerX, centerY - lines[a*8+3]);
#define k (AH/(AD-AH))
        for (unsigned char offset=0;offset<8;offset+=2){
            if(lines[a*8+(2+offset)%8]>lines[a*8+(4+offset)%8]&&lines[a*8+(2+offset)%8]>lines[a*8+offset]&&lines[a*8+(3+offset)%8]>=lines[a*8+1+offset])continue;
            if(lines[a*8+(2+offset)%8]<lines[a*8+(4+offset)%8]&&lines[a*8+(2+offset)%8]<lines[a*8+offset]&&lines[a*8+(3+offset)%8]<=lines[a*8+1+offset])continue; //пропускаємо некрасиві висоти
            if(lines[a*8+(3+offset)%8]>lines[a*8+(5+offset)%8]&&lines[a*8+(3+offset)%8]>lines[a*8+offset+1]&&lines[a*8+(2+offset)%8]>lines[a*8+offset])continue;
            if(lines[a*8+(3+offset)%8]<lines[a*8+(5+offset)%8]&&lines[a*8+(3+offset)%8]<lines[a*8+offset+1]&&lines[a*8+(2+offset)%8]<lines[a*8+offset])continue;
            painter->setPen(Qt::GlobalColor(8+offset));//green, cyan, yellow, dark green
        float AD=sqrt(pow((lines[a*8+offset]-lines[a*8+(6+offset)%8]), 2)+pow((lines[a*8+1+offset]-lines[a*8+(7+offset)%8]),2));
        float AH=((pow((lines[a*8+offset]-lines[a*8+(2+offset)%8]), 2)+pow((lines[a*8+1+offset]-lines[a*8+(3+offset)%8]), 2)+pow(AD,2)-(pow((lines[a*8+(2+offset)%8]-lines[a*8+(6+offset)%8]), 2)+pow(lines[a*8+(3+offset)%8]-lines[a*8+(7+offset)%8], 2)))/2/AD);
        painter->drawLine(lines[a*8+(2+offset)%8] + centerX,centerY-lines[a*8+(3+offset)%8], centerX+(k*lines[a*8+(6+offset)%8]+lines[a*8+offset])/(1+k), centerY-(lines[a*8+1+offset]+k*lines[a*8+(7+offset)%8])/(1+k));
    }
      }

    painter->setPen(Qt::white);painter->setBrush(Qt::NoBrush);
    painter->drawText(centerX - step - 20, centerY + 15, QString::number(-step));
    painter->drawText(centerX + 5, centerY - 5 - step, ' ' + QString::number(step));
    painter->drawText(centerX + 5, 15, "Y");
    painter->drawText(15, centerY - 5, "-X");
    painter->drawText(centerX + 5, centerY - 5, "0");

    if (width() > 750)
        painter->drawText(centerX + step + 5, centerY - 5, QString::number(step));
    char draw=0;
    for (char i=0;i<3;i++)
    if (fields[i][0]->value()||fields[i][1]->value())draw++;
    for (char i=0;i<3;i++)
    if(draw>1||fields[i][0]->value()||fields[i][1]->value())painter->drawEllipse(centerX + fields[i][0]->value()-5, centerY - fields[i][1]->value()-5, 11, 11);
    if(draw){painter->setPen(Qt::red);
    painter->drawEllipse(centerX + Dx - 5, centerY - Dy - 5, 11, 11);}
    if (Dy<0||Dy>newMin||Dx>0||Dx<newMin1||!choosen)button->setEnabled(false);
    else button->setEnabled(true);
    painter->end();
}

void CoordinateSystem::onButtonClick() {
  lines.push_back(Ax);lines.push_back(Ay);
  lines.push_back(Bx);lines.push_back(By);
  lines.push_back(Cx);lines.push_back(Cy);
  lines.push_back(Dx);lines.push_back(Dy);
  colors.push_back(colordialog->selectedColor());
  update();
}
